use thiserror::Error;

use crate::parse::{self};

#[derive(Debug, Error)]
#[error("bag is unindexed")]
pub struct Unindexed;

#[derive(Debug, Error)]
#[error("unsupported encryptor: {0}")]
pub struct UnsupportedEncryptor(pub String);

#[derive(Debug, Error)]
#[error("unsupported bag version: {0}")]
pub struct UnsupportedVersion(pub parse::Version);

#[derive(Debug, Error)]
#[error("unsupported compression: {0}")]
pub struct UnsupportedCompression(pub String);

pub use eyre::{Report as Error, Result};
