mod error;
pub mod header;
mod message;
#[cfg(feature = "bson")]
mod message_bson;
mod version;

pub use error::{Error, ErrorKind};
pub use header::{Header, Op};
pub use message::parse_message;
#[cfg(feature = "bson")]
pub use message_bson::parse_message_bson;
pub use version::Version;

pub type Input<'a> = &'a [u8];
pub type InputOwned = Vec<u8>;
pub type IResult<'a, T> = nom::IResult<Input<'a>, T, Error<Input<'a>>>;

pub type InputStr<'a> = &'a str;
pub type IResultStr<'a, T> = nom::IResult<InputStr<'a>, T, Error<InputStr<'a>>>;

pub type SmallStr = crate::SmallStr;
