use std::{fs::File, sync::Arc};

use memmap::Mmap;

use super::SliceReader;
use crate::Result;

pub type MmapReader = SliceReader<Arc<Mmap>>;

impl MmapReader {
    pub fn map(file: File) -> Result<Self> {
        // Safety: ¯\_(ツ)_/¯
        let mmap = unsafe { Mmap::map(&file) }?;
		let mmap = Arc::new(mmap);
        Ok(SliceReader::from(mmap))
    }
}
